<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html>
<head>
  <title>auto_tag (FontDB)</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <link rel="stylesheet" href="../.././rdoc-style.css" type="text/css" media="screen" />
</head>
<body class="standalone-code">
  <pre><span class="ruby-comment cmt"># File font_db.rb, line 354</span>
  <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">auto_tag</span>(<span class="ruby-identifier">auto_tags</span>, <span class="ruby-identifier">auto_tags_exclusive</span>, 
                    <span class="ruby-identifier">auto_tags_combine</span>, <span class="ruby-identifier">auto_tags_search_columns</span>)
    <span class="ruby-identifier">auto_tags</span>.<span class="ruby-identifier">each</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">tag</span><span class="ruby-operator">|</span>
      <span class="ruby-comment cmt"># Search through all columns given for tags in the auto_tag list.</span>
      <span class="ruby-identifier">all_columns</span> = <span class="ruby-identifier">auto_tags_search_columns</span>.<span class="ruby-identifier">join</span>(<span class="ruby-node">&quot; LIKE '%#{tag}%' OR &quot;</span>)
      <span class="ruby-identifier">ids</span> = <span class="ruby-ivar">@db</span>.<span class="ruby-identifier">execute</span>(<span class="ruby-node">%{
        SELECT id FROM fonts
        WHERE #{all_columns} 
        LIKE '%#{tag}%'
      }</span>)
      <span class="ruby-identifier">add_tags</span>(<span class="ruby-identifier">ids</span>, <span class="ruby-identifier">tag</span>)
    <span class="ruby-keyword kw">end</span>
    
    <span class="ruby-identifier">auto_tags_combine</span>.<span class="ruby-identifier">each_key</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">tag_keep</span><span class="ruby-operator">|</span>
      <span class="ruby-identifier">combine_tags</span>(<span class="ruby-identifier">tag_keep</span>, <span class="ruby-identifier">auto_tags_combine</span>[<span class="ruby-identifier">tag_keep</span>])
    <span class="ruby-keyword kw">end</span>
    
    <span class="ruby-identifier">auto_tags_exclusive</span>.<span class="ruby-identifier">each_key</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">tag_keep</span><span class="ruby-operator">|</span>
      <span class="ruby-identifier">ids</span> = <span class="ruby-identifier">tag_members</span>(<span class="ruby-identifier">tag_keep</span>) <span class="ruby-operator">&amp;</span> <span class="ruby-identifier">tag_members</span>(<span class="ruby-identifier">auto_tags_exclusive</span>[<span class="ruby-identifier">tag_keep</span>])
      <span class="ruby-identifier">remove_tags</span>(<span class="ruby-identifier">ids</span>, (<span class="ruby-identifier">auto_tags_exclusive</span>[<span class="ruby-identifier">tag_keep</span>]))
    <span class="ruby-keyword kw">end</span>
  <span class="ruby-keyword kw">end</span></pre>
</body>
</html>